import{S as ys,i as xs,s as $s,e as s,k as p,w as h,t as o,M as js,c as n,d as i,m as f,a as l,x as g,h as a,b as d,G as t,g as m,y as _,L as Ts,q as z,o as O,B as v,v as ks}from"../../../chunks/vendor-hf-doc-builder.js";import{I as bt}from"../../../chunks/IconCopyLink-hf-doc-builder.js";import{C as G}from"../../../chunks/CodeBlock-hf-doc-builder.js";function Cs(Ea){let T,wt,k,S,De,H,zi,Ie,Oi,Et,E,vi,Ue,bi,wi,W,Ei,yi,yt,C,q,Be,Y,xi,Ge,$i,xt,ve,ji,$t,J,jt,be,Ti,Tt,K,kt,y,ki,He,Ci,Ni,We,Ri,Ai,Ct,N,P,Ye,Q,Li,we,Si,Je,qi,Nt,x,Pi,Ee,Xi,Fi,Ke,Mi,Di,Rt,ye,V,Ii,Qe,Ui,Bi,At,Z,Lt,ee,Ve,Gi,St,te,qt,R,X,Ze,ie,Hi,et,Wi,Pt,$,Yi,xe,Ji,Ki,$e,Qi,Vi,Xt,je,Zi,Ft,b,Te,tt,eo,to,io,ke,it,oo,ao,so,Ce,ot,no,lo,ro,Ne,at,mo,po,Mt,F,fo,oe,uo,co,Dt,A,st,ho,go,nt,_o,zo,It,u,ae,Oo,lt,vo,bo,wo,se,Eo,rt,yo,xo,$o,ne,jo,mt,To,ko,Co,le,No,pt,Ro,Ao,Lo,re,So,ft,qo,Po,Xo,me,Fo,dt,Mo,Do,Io,pe,Uo,ut,Bo,Go,Ut,j,Ho,Re,Wo,Yo,Ae,Jo,Ko,Bt,w,ct,Qo,Vo,fe,Zo,ht,ea,ta,ia,gt,oa,aa,_t,sa,Gt,de,na,Le,la,Ht,ue,Wt,Se,ra,Yt,ce,Jt,L,M,zt,he,ma,Ot,pa,Kt,D,fa,ge,da,ua,Qt,_e,Vt,I,ca,ze,ha,ga,Zt,Oe,ei;return H=new bt({}),Y=new bt({}),J=new G({props:{code:`optimum-cli onnxruntime optimize --help
usage: optimum-cli <command> [<args>] onnxruntime optimize [-h] --onnx_model ONNX_MODEL [-o OUTPUT] (-O1 | -O2 | -O3 | -O4)

options:
  -h, --help            show this help message and exit
  -O1                   Basic general optimizations (see: https://huggingface.co/docs/optimum/onnxruntime/usage_guides/optimization for more details).
  -O2                   Basic and extended general optimizations, transformers-specific fusions (see: https://huggingface.co/docs/optimum/onnxruntime/usage_guides/optimization for more details).
  -O3                   Same as O2 with Gelu approximation (see: https://huggingface.co/docs/optimum/onnxruntime/usage_guides/optimization for more details).
  -O4                   Same as O3 with mixed precision (see: https://huggingface.co/docs/optimum/onnxruntime/usage_guides/optimization for more details).
  -c, --config          \`ORTConfig\` file to use to optimize the model.

Required arguments:
  --onnx_model ONNX_MODEL
                        Path indicating where the ONNX models to optimize are located.

Optional arguments:
  -o OUTPUT, --output OUTPUT
                        Path indicating the directory where to store generated ONNX model. (defaults to --onnx_model value).`,highlighted:`optimum-cli onnxruntime optimize --<span class="hljs-built_in">help</span>
usage: optimum-cli &lt;<span class="hljs-built_in">command</span>&gt; [&lt;args&gt;] onnxruntime optimize [-h] --onnx_model ONNX_MODEL [-o OUTPUT] (-O1 | -O2 | -O3 | -O4)

options:
  -h, --<span class="hljs-built_in">help</span>            show this <span class="hljs-built_in">help</span> message and <span class="hljs-built_in">exit</span>
  -O1                   Basic general optimizations (see: https://huggingface.co/docs/optimum/onnxruntime/usage_guides/optimization <span class="hljs-keyword">for</span> more details).
  -O2                   Basic and extended general optimizations, transformers-specific fusions (see: https://huggingface.co/docs/optimum/onnxruntime/usage_guides/optimization <span class="hljs-keyword">for</span> more details).
  -O3                   Same as O2 with Gelu approximation (see: https://huggingface.co/docs/optimum/onnxruntime/usage_guides/optimization <span class="hljs-keyword">for</span> more details).
  -O4                   Same as O3 with mixed precision (see: https://huggingface.co/docs/optimum/onnxruntime/usage_guides/optimization <span class="hljs-keyword">for</span> more details).
  -c, --config          \`ORTConfig\` file to use to optimize the model.

Required arguments:
  --onnx_model ONNX_MODEL
                        Path indicating <span class="hljs-built_in">where</span> the ONNX models to optimize are located.

Optional arguments:
  -o OUTPUT, --output OUTPUT
                        Path indicating the directory <span class="hljs-built_in">where</span> to store generated ONNX model. (defaults to --onnx_model value).`}}),K=new G({props:{code:" optimum-cli onnxruntime optimize --onnx_model onnx_model_location/ -O1",highlighted:" optimum-cli onnxruntime optimize --onnx_model onnx_model_location/ -O1"}}),Q=new bt({}),Z=new G({props:{code:`from optimum.onnxruntime import ORTOptimizer, ORTModelForSequenceClassification

model = ORTModelForSequenceClassification.from_pretrained(
    "optimum/distilbert-base-uncased-finetuned-sst-2-english"
)

optimizer = ORTOptimizer.from_pretrained(model)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTOptimizer, ORTModelForSequenceClassification

<span class="hljs-comment"># Loading ONNX Model from the Hub</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForSequenceClassification.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;optimum/distilbert-base-uncased-finetuned-sst-2-english&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-comment"># Create an optimizer from an ORTModelForXXX</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = ORTOptimizer.from_pretrained(model)`}}),te=new G({props:{code:`from optimum.onnxruntime import ORTOptimizer

optimizer = ORTOptimizer.from_pretrained("path/to/model")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTOptimizer

<span class="hljs-comment"># This assumes a model.onnx exists in path/to/model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = ORTOptimizer.from_pretrained(<span class="hljs-string">&quot;path/to/model&quot;</span>)`}}),ie=new bt({}),ue=new G({props:{code:`from optimum.onnxruntime import AutoOptimizationConfig
optimization_config = AutoOptimizationConfig.O2()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> AutoOptimizationConfig
<span class="hljs-meta">&gt;&gt;&gt; </span>optimization_config = AutoOptimizationConfig.O2()`}}),ce=new G({props:{code:`from optimum.onnxruntime import AutoOptimizationConfig
optimization_config = AutoOptimizationConfig.O2(disable_embed_layer_norm_fusion=False)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> AutoOptimizationConfig
<span class="hljs-meta">&gt;&gt;&gt; </span>optimization_config = AutoOptimizationConfig.O2(disable_embed_layer_norm_fusion=<span class="hljs-literal">False</span>)`}}),he=new bt({}),_e=new G({props:{code:`from optimum.onnxruntime import (
    AutoOptimizationConfig, ORTOptimizer, ORTModelForSequenceClassification
)

model_id = "distilbert-base-uncased-finetuned-sst-2-english"
save_dir = "distilbert_optimized"

# Load a PyTorch model and export it to the ONNX format
model = ORTModelForSequenceClassification.from_pretrained(model_id, from_transformers=True)

# Create the optimizer
optimizer = ORTOptimizer.from_pretrained(model)

# Define the optimization strategy by creating the appropriate configuration
optimization_config = AutoOptimizationConfig.O2()

# Optimize the model
optimizer.optimize(save_dir=save_dir, optimization_config=optimization_config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> (
<span class="hljs-meta">... </span>    AutoOptimizationConfig, ORTOptimizer, ORTModelForSequenceClassification
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>model_id = <span class="hljs-string">&quot;distilbert-base-uncased-finetuned-sst-2-english&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>save_dir = <span class="hljs-string">&quot;distilbert_optimized&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Load a PyTorch model and export it to the ONNX format</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForSequenceClassification.from_pretrained(model_id, from_transformers=<span class="hljs-literal">True</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Create the optimizer</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = ORTOptimizer.from_pretrained(model)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Define the optimization strategy by creating the appropriate configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimization_config = AutoOptimizationConfig.O2()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Optimize the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.optimize(save_dir=save_dir, optimization_config=optimization_config)`}}),Oe=new G({props:{code:`from transformers import AutoTokenizer
from optimum.onnxruntime import  OptimizationConfig, ORTOptimizer, ORTModelForSeq2SeqLM

model_id = "sshleifer/distilbart-cnn-12-6"
save_dir = "distilbart_optimized"

# Load a PyTorch model and export it to the ONNX format
model = ORTModelForSeq2SeqLM.from_pretrained(model_id, from_transformers=True)

# Create the optimizer
optimizer = ORTOptimizer.from_pretrained(model)

# Define the optimization strategy by creating the appropriate configuration
optimization_config = OptimizationConfig(
    optimization_level=2,
    enable_transformers_specific_optimizations=True,
    optimize_for_gpu=False,
)

# Optimize the model
optimizer.optimize(save_dir=save_dir, optimization_config=optimization_config)
tokenizer = AutoTokenizer.from_pretrained(model_id)
optimized_model = ORTModelForSeq2SeqLM.from_pretrained(save_dir)
tokens = tokenizer("This is a sample input", return_tensors="pt")
outputs = optimized_model.generate(**tokens)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span>  OptimizationConfig, ORTOptimizer, ORTModelForSeq2SeqLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model_id = <span class="hljs-string">&quot;sshleifer/distilbart-cnn-12-6&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>save_dir = <span class="hljs-string">&quot;distilbart_optimized&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Load a PyTorch model and export it to the ONNX format</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForSeq2SeqLM.from_pretrained(model_id, from_transformers=<span class="hljs-literal">True</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Create the optimizer</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = ORTOptimizer.from_pretrained(model)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Define the optimization strategy by creating the appropriate configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimization_config = OptimizationConfig(
<span class="hljs-meta">... </span>    optimization_level=<span class="hljs-number">2</span>,
<span class="hljs-meta">... </span>    enable_transformers_specific_optimizations=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    optimize_for_gpu=<span class="hljs-literal">False</span>,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Optimize the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.optimize(save_dir=save_dir, optimization_config=optimization_config)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(model_id)
<span class="hljs-meta">&gt;&gt;&gt; </span>optimized_model = ORTModelForSeq2SeqLM.from_pretrained(save_dir)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokens = tokenizer(<span class="hljs-string">&quot;This is a sample input&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = optimized_model.generate(**tokens)`}}),{c(){T=s("meta"),wt=p(),k=s("h1"),S=s("a"),De=s("span"),h(H.$$.fragment),zi=p(),Ie=s("span"),Oi=o("Optimization"),Et=p(),E=s("p"),vi=o("\u{1F917} Optimum provides an "),Ue=s("code"),bi=o("optimum.onnxruntime"),wi=o(" package that enables you to apply graph optimization on many model hosted on the \u{1F917} hub using the "),W=s("a"),Ei=o("ONNX Runtime"),yi=o(" model optimization tool."),yt=p(),C=s("h2"),q=s("a"),Be=s("span"),h(Y.$$.fragment),xi=p(),Ge=s("span"),$i=o("Optimizing a model to be used with Optimum's CLI"),xt=p(),ve=s("p"),ji=o("The Optimum ONNX Runtime optimization tool can be used through Optimum command-line interface:"),$t=p(),h(J.$$.fragment),jt=p(),be=s("p"),Ti=o("Optimizing an ONNX model can be done as follows:"),Tt=p(),h(K.$$.fragment),kt=p(),y=s("p"),ki=o("This optimize all the ONNX files in "),He=s("code"),Ci=o("onnx_model_location"),Ni=o(" with the basic general optimizations. The optimized models will be created in the same directory by default unless the "),We=s("code"),Ri=o("--output"),Ai=o(" argument is specified."),Ct=p(),N=s("h2"),P=s("a"),Ye=s("span"),h(Q.$$.fragment),Li=p(),we=s("span"),Si=o("Optimizing a model to be used with Optimum's "),Je=s("code"),qi=o("ORTOptimizer"),Nt=p(),x=s("p"),Pi=o("The "),Ee=s("a"),Xi=o("ORTOptimizer"),Fi=o(" class is used to optimize your ONNX model. The class can be initialized using the "),Ke=s("code"),Mi=o("from_pretrained()"),Di=o(" method, which supports different checkpoint formats."),Rt=p(),ye=s("ol"),V=s("li"),Ii=o("Using an already initialized "),Qe=s("code"),Ui=o("ORTModelForXXX"),Bi=o(" class."),At=p(),h(Z.$$.fragment),Lt=p(),ee=s("ol"),Ve=s("li"),Gi=o("Using a local ONNX model from a directory."),St=p(),h(te.$$.fragment),qt=p(),R=s("h2"),X=s("a"),Ze=s("span"),h(ie.$$.fragment),Hi=p(),et=s("span"),Wi=o("Optimization Configuration"),Pt=p(),$=s("p"),Yi=o("The "),xe=s("a"),Ji=o("OptimizationConfig"),Ki=o(" class allows to specify how the optimization should be performed by the "),$e=s("a"),Qi=o("ORTOptimizer"),Vi=o("."),Xt=p(),je=s("p"),Zi=o("In the optimization configuration, there are 4 possible optimization levels:"),Ft=p(),b=s("ul"),Te=s("li"),tt=s("code"),eo=o("optimization_level=0"),to=o(": to disable all optimizations"),io=p(),ke=s("li"),it=s("code"),oo=o("optimization_level=1"),ao=o(": to enable basic optimizations such as constant folding or redundant node eliminations"),so=p(),Ce=s("li"),ot=s("code"),no=o("optimization_level=2"),lo=o(": to enable extended graph optimizations such as node fusions"),ro=p(),Ne=s("li"),at=s("code"),mo=o("optimization_level=99"),po=o(": to enable data layout optimizations"),Mt=p(),F=s("p"),fo=o(`Choosing a level enables the optimizations of that level, as well as the optimizations of all preceding levels.
More information `),oe=s("a"),uo=o("here"),co=o("."),Dt=p(),A=s("p"),st=s("code"),ho=o("enable_transformers_specific_optimizations=True"),go=o(" means that "),nt=s("code"),_o=o("transformers"),zo=o(`-specific graph fusion and approximation are performed in addition to the ONNX Runtime optimizations described above.
Here is a list of the possible optimizations you can enable:`),It=p(),u=s("ul"),ae=s("li"),Oo=o("Gelu fusion with "),lt=s("code"),vo=o("disable_gelu_fusion=False"),bo=o(","),wo=p(),se=s("li"),Eo=o("Layer Normalization fusion with "),rt=s("code"),yo=o("disable_layer_norm_fusion=False"),xo=o(","),$o=p(),ne=s("li"),jo=o("Attention fusion with "),mt=s("code"),To=o("disable_attention_fusion=False"),ko=o(","),Co=p(),le=s("li"),No=o("SkipLayerNormalization fusion with "),pt=s("code"),Ro=o("disable_skip_layer_norm_fusion=False"),Ao=o(","),Lo=p(),re=s("li"),So=o("Add Bias and SkipLayerNormalization fusion with "),ft=s("code"),qo=o("disable_bias_skip_layer_norm_fusion=False"),Po=o(","),Xo=p(),me=s("li"),Fo=o("Add Bias and Gelu / FastGelu fusion with "),dt=s("code"),Mo=o("disable_bias_gelu_fusion=False"),Do=o(","),Io=p(),pe=s("li"),Uo=o("Gelu approximation with "),ut=s("code"),Bo=o("enable_gelu_approximation=True"),Go=o("."),Ut=p(),j=s("p"),Ho=o("While "),Re=s("a"),Wo=o("OptimizationConfig"),Yo=o(" gives you full control on how to do optimization, it can be hard to know what to enable / disable. Instead, you can use "),Ae=s("a"),Jo=o("AutoOptimizationConfig"),Ko=o(" which provides 3 common optimizations levels:"),Bt=p(),w=s("ul"),ct=s("li"),Qo=o("O1: basic general optimizations."),Vo=p(),fe=s("li"),Zo=o("O2: basic and extended general optimizations, "),ht=s("code"),ea=o("transformers"),ta=o("-specific fusions."),ia=p(),gt=s("li"),oa=o("O3: same as O2 with Gelu approximation."),aa=p(),_t=s("li"),sa=o("O4: same as O3 with mixed precision."),Gt=p(),de=s("p"),na=o("Example: Loading a O2 "),Le=s("a"),la=o("OptimizationConfig"),Ht=p(),h(ue.$$.fragment),Wt=p(),Se=s("p"),ra=o("You can also specify custom argument that were not defined in the O2 configuration, for instance:"),Yt=p(),h(ce.$$.fragment),Jt=p(),L=s("h2"),M=s("a"),zt=s("span"),h(he.$$.fragment),ma=p(),Ot=s("span"),pa=o("Optimization examples"),Kt=p(),D=s("p"),fa=o("Below you will find an easy end-to-end example on how to optimize "),ge=s("a"),da=o("distilbert-base-uncased-finetuned-sst-2-english"),ua=o("."),Qt=p(),h(_e.$$.fragment),Vt=p(),I=s("p"),ca=o("Below you will find an easy end-to-end example on how to optimize a Seq2Seq model "),ze=s("a"),ha=o("sshleifer/distilbart-cnn-12-6\u201D"),ga=o("."),Zt=p(),h(Oe.$$.fragment),this.h()},l(e){const r=js('[data-svelte="svelte-1phssyn"]',document.head);T=n(r,"META",{name:!0,content:!0}),r.forEach(i),wt=f(e),k=n(e,"H1",{class:!0});var ti=l(k);S=n(ti,"A",{id:!0,class:!0,href:!0});var ya=l(S);De=n(ya,"SPAN",{});var xa=l(De);g(H.$$.fragment,xa),xa.forEach(i),ya.forEach(i),zi=f(ti),Ie=n(ti,"SPAN",{});var $a=l(Ie);Oi=a($a,"Optimization"),$a.forEach(i),ti.forEach(i),Et=f(e),E=n(e,"P",{});var qe=l(E);vi=a(qe,"\u{1F917} Optimum provides an "),Ue=n(qe,"CODE",{});var ja=l(Ue);bi=a(ja,"optimum.onnxruntime"),ja.forEach(i),wi=a(qe," package that enables you to apply graph optimization on many model hosted on the \u{1F917} hub using the "),W=n(qe,"A",{href:!0,rel:!0});var Ta=l(W);Ei=a(Ta,"ONNX Runtime"),Ta.forEach(i),yi=a(qe," model optimization tool."),qe.forEach(i),yt=f(e),C=n(e,"H2",{class:!0});var ii=l(C);q=n(ii,"A",{id:!0,class:!0,href:!0});var ka=l(q);Be=n(ka,"SPAN",{});var Ca=l(Be);g(Y.$$.fragment,Ca),Ca.forEach(i),ka.forEach(i),xi=f(ii),Ge=n(ii,"SPAN",{});var Na=l(Ge);$i=a(Na,"Optimizing a model to be used with Optimum's CLI"),Na.forEach(i),ii.forEach(i),xt=f(e),ve=n(e,"P",{});var Ra=l(ve);ji=a(Ra,"The Optimum ONNX Runtime optimization tool can be used through Optimum command-line interface:"),Ra.forEach(i),$t=f(e),g(J.$$.fragment,e),jt=f(e),be=n(e,"P",{});var Aa=l(be);Ti=a(Aa,"Optimizing an ONNX model can be done as follows:"),Aa.forEach(i),Tt=f(e),g(K.$$.fragment,e),kt=f(e),y=n(e,"P",{});var Pe=l(y);ki=a(Pe,"This optimize all the ONNX files in "),He=n(Pe,"CODE",{});var La=l(He);Ci=a(La,"onnx_model_location"),La.forEach(i),Ni=a(Pe," with the basic general optimizations. The optimized models will be created in the same directory by default unless the "),We=n(Pe,"CODE",{});var Sa=l(We);Ri=a(Sa,"--output"),Sa.forEach(i),Ai=a(Pe," argument is specified."),Pe.forEach(i),Ct=f(e),N=n(e,"H2",{class:!0});var oi=l(N);P=n(oi,"A",{id:!0,class:!0,href:!0});var qa=l(P);Ye=n(qa,"SPAN",{});var Pa=l(Ye);g(Q.$$.fragment,Pa),Pa.forEach(i),qa.forEach(i),Li=f(oi),we=n(oi,"SPAN",{});var _a=l(we);Si=a(_a,"Optimizing a model to be used with Optimum's "),Je=n(_a,"CODE",{});var Xa=l(Je);qi=a(Xa,"ORTOptimizer"),Xa.forEach(i),_a.forEach(i),oi.forEach(i),Nt=f(e),x=n(e,"P",{});var Xe=l(x);Pi=a(Xe,"The "),Ee=n(Xe,"A",{href:!0});var Fa=l(Ee);Xi=a(Fa,"ORTOptimizer"),Fa.forEach(i),Fi=a(Xe," class is used to optimize your ONNX model. The class can be initialized using the "),Ke=n(Xe,"CODE",{});var Ma=l(Ke);Mi=a(Ma,"from_pretrained()"),Ma.forEach(i),Di=a(Xe," method, which supports different checkpoint formats."),Xe.forEach(i),Rt=f(e),ye=n(e,"OL",{});var Da=l(ye);V=n(Da,"LI",{});var ai=l(V);Ii=a(ai,"Using an already initialized "),Qe=n(ai,"CODE",{});var Ia=l(Qe);Ui=a(Ia,"ORTModelForXXX"),Ia.forEach(i),Bi=a(ai," class."),ai.forEach(i),Da.forEach(i),At=f(e),g(Z.$$.fragment,e),Lt=f(e),ee=n(e,"OL",{start:!0});var Ua=l(ee);Ve=n(Ua,"LI",{});var Ba=l(Ve);Gi=a(Ba,"Using a local ONNX model from a directory."),Ba.forEach(i),Ua.forEach(i),St=f(e),g(te.$$.fragment,e),qt=f(e),R=n(e,"H2",{class:!0});var si=l(R);X=n(si,"A",{id:!0,class:!0,href:!0});var Ga=l(X);Ze=n(Ga,"SPAN",{});var Ha=l(Ze);g(ie.$$.fragment,Ha),Ha.forEach(i),Ga.forEach(i),Hi=f(si),et=n(si,"SPAN",{});var Wa=l(et);Wi=a(Wa,"Optimization Configuration"),Wa.forEach(i),si.forEach(i),Pt=f(e),$=n(e,"P",{});var Fe=l($);Yi=a(Fe,"The "),xe=n(Fe,"A",{href:!0});var Ya=l(xe);Ji=a(Ya,"OptimizationConfig"),Ya.forEach(i),Ki=a(Fe," class allows to specify how the optimization should be performed by the "),$e=n(Fe,"A",{href:!0});var Ja=l($e);Qi=a(Ja,"ORTOptimizer"),Ja.forEach(i),Vi=a(Fe,"."),Fe.forEach(i),Xt=f(e),je=n(e,"P",{});var Ka=l(je);Zi=a(Ka,"In the optimization configuration, there are 4 possible optimization levels:"),Ka.forEach(i),Ft=f(e),b=n(e,"UL",{});var U=l(b);Te=n(U,"LI",{});var za=l(Te);tt=n(za,"CODE",{});var Qa=l(tt);eo=a(Qa,"optimization_level=0"),Qa.forEach(i),to=a(za,": to disable all optimizations"),za.forEach(i),io=f(U),ke=n(U,"LI",{});var Oa=l(ke);it=n(Oa,"CODE",{});var Va=l(it);oo=a(Va,"optimization_level=1"),Va.forEach(i),ao=a(Oa,": to enable basic optimizations such as constant folding or redundant node eliminations"),Oa.forEach(i),so=f(U),Ce=n(U,"LI",{});var va=l(Ce);ot=n(va,"CODE",{});var Za=l(ot);no=a(Za,"optimization_level=2"),Za.forEach(i),lo=a(va,": to enable extended graph optimizations such as node fusions"),va.forEach(i),ro=f(U),Ne=n(U,"LI",{});var ba=l(Ne);at=n(ba,"CODE",{});var es=l(at);mo=a(es,"optimization_level=99"),es.forEach(i),po=a(ba,": to enable data layout optimizations"),ba.forEach(i),U.forEach(i),Mt=f(e),F=n(e,"P",{});var ni=l(F);fo=a(ni,`Choosing a level enables the optimizations of that level, as well as the optimizations of all preceding levels.
More information `),oe=n(ni,"A",{href:!0,rel:!0});var ts=l(oe);uo=a(ts,"here"),ts.forEach(i),co=a(ni,"."),ni.forEach(i),Dt=f(e),A=n(e,"P",{});var vt=l(A);st=n(vt,"CODE",{});var is=l(st);ho=a(is,"enable_transformers_specific_optimizations=True"),is.forEach(i),go=a(vt," means that "),nt=n(vt,"CODE",{});var os=l(nt);_o=a(os,"transformers"),os.forEach(i),zo=a(vt,`-specific graph fusion and approximation are performed in addition to the ONNX Runtime optimizations described above.
Here is a list of the possible optimizations you can enable:`),vt.forEach(i),It=f(e),u=n(e,"UL",{});var c=l(u);ae=n(c,"LI",{});var li=l(ae);Oo=a(li,"Gelu fusion with "),lt=n(li,"CODE",{});var as=l(lt);vo=a(as,"disable_gelu_fusion=False"),as.forEach(i),bo=a(li,","),li.forEach(i),wo=f(c),se=n(c,"LI",{});var ri=l(se);Eo=a(ri,"Layer Normalization fusion with "),rt=n(ri,"CODE",{});var ss=l(rt);yo=a(ss,"disable_layer_norm_fusion=False"),ss.forEach(i),xo=a(ri,","),ri.forEach(i),$o=f(c),ne=n(c,"LI",{});var mi=l(ne);jo=a(mi,"Attention fusion with "),mt=n(mi,"CODE",{});var ns=l(mt);To=a(ns,"disable_attention_fusion=False"),ns.forEach(i),ko=a(mi,","),mi.forEach(i),Co=f(c),le=n(c,"LI",{});var pi=l(le);No=a(pi,"SkipLayerNormalization fusion with "),pt=n(pi,"CODE",{});var ls=l(pt);Ro=a(ls,"disable_skip_layer_norm_fusion=False"),ls.forEach(i),Ao=a(pi,","),pi.forEach(i),Lo=f(c),re=n(c,"LI",{});var fi=l(re);So=a(fi,"Add Bias and SkipLayerNormalization fusion with "),ft=n(fi,"CODE",{});var rs=l(ft);qo=a(rs,"disable_bias_skip_layer_norm_fusion=False"),rs.forEach(i),Po=a(fi,","),fi.forEach(i),Xo=f(c),me=n(c,"LI",{});var di=l(me);Fo=a(di,"Add Bias and Gelu / FastGelu fusion with "),dt=n(di,"CODE",{});var ms=l(dt);Mo=a(ms,"disable_bias_gelu_fusion=False"),ms.forEach(i),Do=a(di,","),di.forEach(i),Io=f(c),pe=n(c,"LI",{});var ui=l(pe);Uo=a(ui,"Gelu approximation with "),ut=n(ui,"CODE",{});var ps=l(ut);Bo=a(ps,"enable_gelu_approximation=True"),ps.forEach(i),Go=a(ui,"."),ui.forEach(i),c.forEach(i),Ut=f(e),j=n(e,"P",{});var Me=l(j);Ho=a(Me,"While "),Re=n(Me,"A",{href:!0});var fs=l(Re);Wo=a(fs,"OptimizationConfig"),fs.forEach(i),Yo=a(Me," gives you full control on how to do optimization, it can be hard to know what to enable / disable. Instead, you can use "),Ae=n(Me,"A",{href:!0});var ds=l(Ae);Jo=a(ds,"AutoOptimizationConfig"),ds.forEach(i),Ko=a(Me," which provides 3 common optimizations levels:"),Me.forEach(i),Bt=f(e),w=n(e,"UL",{});var B=l(w);ct=n(B,"LI",{});var us=l(ct);Qo=a(us,"O1: basic general optimizations."),us.forEach(i),Vo=f(B),fe=n(B,"LI",{});var ci=l(fe);Zo=a(ci,"O2: basic and extended general optimizations, "),ht=n(ci,"CODE",{});var cs=l(ht);ea=a(cs,"transformers"),cs.forEach(i),ta=a(ci,"-specific fusions."),ci.forEach(i),ia=f(B),gt=n(B,"LI",{});var hs=l(gt);oa=a(hs,"O3: same as O2 with Gelu approximation."),hs.forEach(i),aa=f(B),_t=n(B,"LI",{});var gs=l(_t);sa=a(gs,"O4: same as O3 with mixed precision."),gs.forEach(i),B.forEach(i),Gt=f(e),de=n(e,"P",{});var wa=l(de);na=a(wa,"Example: Loading a O2 "),Le=n(wa,"A",{href:!0});var _s=l(Le);la=a(_s,"OptimizationConfig"),_s.forEach(i),wa.forEach(i),Ht=f(e),g(ue.$$.fragment,e),Wt=f(e),Se=n(e,"P",{});var zs=l(Se);ra=a(zs,"You can also specify custom argument that were not defined in the O2 configuration, for instance:"),zs.forEach(i),Yt=f(e),g(ce.$$.fragment,e),Jt=f(e),L=n(e,"H2",{class:!0});var hi=l(L);M=n(hi,"A",{id:!0,class:!0,href:!0});var Os=l(M);zt=n(Os,"SPAN",{});var vs=l(zt);g(he.$$.fragment,vs),vs.forEach(i),Os.forEach(i),ma=f(hi),Ot=n(hi,"SPAN",{});var bs=l(Ot);pa=a(bs,"Optimization examples"),bs.forEach(i),hi.forEach(i),Kt=f(e),D=n(e,"P",{});var gi=l(D);fa=a(gi,"Below you will find an easy end-to-end example on how to optimize "),ge=n(gi,"A",{href:!0,rel:!0});var ws=l(ge);da=a(ws,"distilbert-base-uncased-finetuned-sst-2-english"),ws.forEach(i),ua=a(gi,"."),gi.forEach(i),Qt=f(e),g(_e.$$.fragment,e),Vt=f(e),I=n(e,"P",{});var _i=l(I);ca=a(_i,"Below you will find an easy end-to-end example on how to optimize a Seq2Seq model "),ze=n(_i,"A",{href:!0,rel:!0});var Es=l(ze);ha=a(Es,"sshleifer/distilbart-cnn-12-6\u201D"),Es.forEach(i),ga=a(_i,"."),_i.forEach(i),Zt=f(e),g(Oe.$$.fragment,e),this.h()},h(){d(T,"name","hf:doc:metadata"),d(T,"content",JSON.stringify(Ns)),d(S,"id","optimization"),d(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(S,"href","#optimization"),d(k,"class","relative group"),d(W,"href","https://github.com/microsoft/onnxruntime/tree/master/onnxruntime/python/tools/transformers"),d(W,"rel","nofollow"),d(q,"id","optimizing-a-model-to-be-used-with-optimums-cli"),d(q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(q,"href","#optimizing-a-model-to-be-used-with-optimums-cli"),d(C,"class","relative group"),d(P,"id","optimizing-a-model-to-be-used-with-optimums-ortoptimizer"),d(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(P,"href","#optimizing-a-model-to-be-used-with-optimums-ortoptimizer"),d(N,"class","relative group"),d(Ee,"href","/docs/optimum/main/en/onnxruntime/package_reference/optimization#optimum.onnxruntime.ORTOptimizer"),d(ee,"start","2"),d(X,"id","optimization-configuration"),d(X,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(X,"href","#optimization-configuration"),d(R,"class","relative group"),d(xe,"href","/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.OptimizationConfig"),d($e,"href","/docs/optimum/main/en/onnxruntime/package_reference/optimization#optimum.onnxruntime.ORTOptimizer"),d(oe,"href","https://onnxruntime.ai/docs/performance/graph-optimizations.html"),d(oe,"rel","nofollow"),d(Re,"href","/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.OptimizationConfig"),d(Ae,"href","/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.AutoOptimizationConfig"),d(Le,"href","/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.OptimizationConfig"),d(M,"id","optimization-examples"),d(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(M,"href","#optimization-examples"),d(L,"class","relative group"),d(ge,"href","https://huggingface.co/distilbert-base-uncased-finetuned-sst-2-english"),d(ge,"rel","nofollow"),d(ze,"href","https://huggingface.co/sshleifer/distilbart-cnn-12-6"),d(ze,"rel","nofollow")},m(e,r){t(document.head,T),m(e,wt,r),m(e,k,r),t(k,S),t(S,De),_(H,De,null),t(k,zi),t(k,Ie),t(Ie,Oi),m(e,Et,r),m(e,E,r),t(E,vi),t(E,Ue),t(Ue,bi),t(E,wi),t(E,W),t(W,Ei),t(E,yi),m(e,yt,r),m(e,C,r),t(C,q),t(q,Be),_(Y,Be,null),t(C,xi),t(C,Ge),t(Ge,$i),m(e,xt,r),m(e,ve,r),t(ve,ji),m(e,$t,r),_(J,e,r),m(e,jt,r),m(e,be,r),t(be,Ti),m(e,Tt,r),_(K,e,r),m(e,kt,r),m(e,y,r),t(y,ki),t(y,He),t(He,Ci),t(y,Ni),t(y,We),t(We,Ri),t(y,Ai),m(e,Ct,r),m(e,N,r),t(N,P),t(P,Ye),_(Q,Ye,null),t(N,Li),t(N,we),t(we,Si),t(we,Je),t(Je,qi),m(e,Nt,r),m(e,x,r),t(x,Pi),t(x,Ee),t(Ee,Xi),t(x,Fi),t(x,Ke),t(Ke,Mi),t(x,Di),m(e,Rt,r),m(e,ye,r),t(ye,V),t(V,Ii),t(V,Qe),t(Qe,Ui),t(V,Bi),m(e,At,r),_(Z,e,r),m(e,Lt,r),m(e,ee,r),t(ee,Ve),t(Ve,Gi),m(e,St,r),_(te,e,r),m(e,qt,r),m(e,R,r),t(R,X),t(X,Ze),_(ie,Ze,null),t(R,Hi),t(R,et),t(et,Wi),m(e,Pt,r),m(e,$,r),t($,Yi),t($,xe),t(xe,Ji),t($,Ki),t($,$e),t($e,Qi),t($,Vi),m(e,Xt,r),m(e,je,r),t(je,Zi),m(e,Ft,r),m(e,b,r),t(b,Te),t(Te,tt),t(tt,eo),t(Te,to),t(b,io),t(b,ke),t(ke,it),t(it,oo),t(ke,ao),t(b,so),t(b,Ce),t(Ce,ot),t(ot,no),t(Ce,lo),t(b,ro),t(b,Ne),t(Ne,at),t(at,mo),t(Ne,po),m(e,Mt,r),m(e,F,r),t(F,fo),t(F,oe),t(oe,uo),t(F,co),m(e,Dt,r),m(e,A,r),t(A,st),t(st,ho),t(A,go),t(A,nt),t(nt,_o),t(A,zo),m(e,It,r),m(e,u,r),t(u,ae),t(ae,Oo),t(ae,lt),t(lt,vo),t(ae,bo),t(u,wo),t(u,se),t(se,Eo),t(se,rt),t(rt,yo),t(se,xo),t(u,$o),t(u,ne),t(ne,jo),t(ne,mt),t(mt,To),t(ne,ko),t(u,Co),t(u,le),t(le,No),t(le,pt),t(pt,Ro),t(le,Ao),t(u,Lo),t(u,re),t(re,So),t(re,ft),t(ft,qo),t(re,Po),t(u,Xo),t(u,me),t(me,Fo),t(me,dt),t(dt,Mo),t(me,Do),t(u,Io),t(u,pe),t(pe,Uo),t(pe,ut),t(ut,Bo),t(pe,Go),m(e,Ut,r),m(e,j,r),t(j,Ho),t(j,Re),t(Re,Wo),t(j,Yo),t(j,Ae),t(Ae,Jo),t(j,Ko),m(e,Bt,r),m(e,w,r),t(w,ct),t(ct,Qo),t(w,Vo),t(w,fe),t(fe,Zo),t(fe,ht),t(ht,ea),t(fe,ta),t(w,ia),t(w,gt),t(gt,oa),t(w,aa),t(w,_t),t(_t,sa),m(e,Gt,r),m(e,de,r),t(de,na),t(de,Le),t(Le,la),m(e,Ht,r),_(ue,e,r),m(e,Wt,r),m(e,Se,r),t(Se,ra),m(e,Yt,r),_(ce,e,r),m(e,Jt,r),m(e,L,r),t(L,M),t(M,zt),_(he,zt,null),t(L,ma),t(L,Ot),t(Ot,pa),m(e,Kt,r),m(e,D,r),t(D,fa),t(D,ge),t(ge,da),t(D,ua),m(e,Qt,r),_(_e,e,r),m(e,Vt,r),m(e,I,r),t(I,ca),t(I,ze),t(ze,ha),t(I,ga),m(e,Zt,r),_(Oe,e,r),ei=!0},p:Ts,i(e){ei||(z(H.$$.fragment,e),z(Y.$$.fragment,e),z(J.$$.fragment,e),z(K.$$.fragment,e),z(Q.$$.fragment,e),z(Z.$$.fragment,e),z(te.$$.fragment,e),z(ie.$$.fragment,e),z(ue.$$.fragment,e),z(ce.$$.fragment,e),z(he.$$.fragment,e),z(_e.$$.fragment,e),z(Oe.$$.fragment,e),ei=!0)},o(e){O(H.$$.fragment,e),O(Y.$$.fragment,e),O(J.$$.fragment,e),O(K.$$.fragment,e),O(Q.$$.fragment,e),O(Z.$$.fragment,e),O(te.$$.fragment,e),O(ie.$$.fragment,e),O(ue.$$.fragment,e),O(ce.$$.fragment,e),O(he.$$.fragment,e),O(_e.$$.fragment,e),O(Oe.$$.fragment,e),ei=!1},d(e){i(T),e&&i(wt),e&&i(k),v(H),e&&i(Et),e&&i(E),e&&i(yt),e&&i(C),v(Y),e&&i(xt),e&&i(ve),e&&i($t),v(J,e),e&&i(jt),e&&i(be),e&&i(Tt),v(K,e),e&&i(kt),e&&i(y),e&&i(Ct),e&&i(N),v(Q),e&&i(Nt),e&&i(x),e&&i(Rt),e&&i(ye),e&&i(At),v(Z,e),e&&i(Lt),e&&i(ee),e&&i(St),v(te,e),e&&i(qt),e&&i(R),v(ie),e&&i(Pt),e&&i($),e&&i(Xt),e&&i(je),e&&i(Ft),e&&i(b),e&&i(Mt),e&&i(F),e&&i(Dt),e&&i(A),e&&i(It),e&&i(u),e&&i(Ut),e&&i(j),e&&i(Bt),e&&i(w),e&&i(Gt),e&&i(de),e&&i(Ht),v(ue,e),e&&i(Wt),e&&i(Se),e&&i(Yt),v(ce,e),e&&i(Jt),e&&i(L),v(he),e&&i(Kt),e&&i(D),e&&i(Qt),v(_e,e),e&&i(Vt),e&&i(I),e&&i(Zt),v(Oe,e)}}}const Ns={local:"optimization",sections:[{local:"optimizing-a-model-to-be-used-with-optimums-cli",title:"Optimizing a model to be used with Optimum's CLI"},{local:"optimizing-a-model-to-be-used-with-optimums-ortoptimizer",title:"Optimizing a model to be used with Optimum's `ORTOptimizer`"},{local:"optimization-configuration",title:"Optimization Configuration"},{local:"optimization-examples",title:"Optimization examples"}],title:"Optimization"};function Rs(Ea){return ks(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qs extends ys{constructor(T){super();xs(this,T,Rs,Cs,$s,{})}}export{qs as default,Ns as metadata};
